local addonName, XUB = ...;

function XUB_CheckBuffCondition(myButton)

	if not myButton.Condition then
		return
	end
	
	local l_found = false
	
	for i = 1,#myButton.Condition do
		if XUB.AllBuffs2[myButton.Condition[i].name] then 		-- if my condition is in the list of buffs
			if myButton.Condition[i].inverted then
				return --button is not in state 'is_STATE_BUFFED'
			elseif (myButton.Condition[i].selfCast < XUB.AllBuffs2[myButton.Condition[i].name].selfCast) then
				myButton.is_STATE_BUFFED = 1
				myButton.LastsTill = XUB.AllBuffs2[myButton.Condition[i].name].expiryTime
				return
			else
				-- do nothing. condition is found, but the self condition does not fit. Continue checking
			end
		end
	end

end


function XUB_CheckDebuffCondition(myButton)

	if not myButton.Condition then
		return
	end

	local l_found = false

	myButton.is_STATE_INVALID = 1;
	
	for i = 1,#myButton.Condition do
		if (myButton.Condition[i].name == "purge") and (XUB.AllBuffs2 ~= {}) then
			myButton.is_STATE_INVALID = nil
			return
		elseif (myButton.Condition[i].name == "death") and UnitIsDeadOrGhost(myButton.DestinationUnit) then
			myButton.is_STATE_INVALID = nil
			return
		elseif XUB.AllDebuffTypes[myButton.Condition[i].name] then 	-- if the condition is in the list of debufftypes
			myButton.is_STATE_INVALID = nil
			myButton.LastsTill = XUB.AllDebuffTypes[myButton.Condition[i].name].expiryTime
			return
		elseif	XUB.AllBuffs2[myButton.Condition[i].name] then 	-- if the condition is in the list of buffs
			if (myButton.Condition[i].selfCast < XUB.AllBuffs2[myButton.Condition[i].name].selfCast) then
				myButton.is_STATE_INVALID = nil
				myButton.LastsTill = XUB.AllBuffs2[myButton.Condition[i].name].expiryTime
				return
			end
		end
	end

end


function  XUB_CheckHealthCondition(myButton)

	if ( myButton.Threshold > 0 ) then

		local myUnitDamage = UnitHealthMax(myButton.DestinationUnit) - UnitHealth(myButton.DestinationUnit);

		if ( myUnitDamage < myButton.Threshold ) then
			myButton.is_STATE_HEALTHOFF = 1;
		end

	elseif ( myButton.Threshold < 0 ) then

		local myShow = 0;

		if ( myButton.DestinationUnit ~= "target" ) then
			myButton.is_STATE_INVALID = 1;
		else
			if ( XUB.LastHealthTarget > 0 ) then
				local healthDiff = XUB.LastHealthTarget - UnitHealth("target");
				if ( healthDiff > 0 ) then
					XUB.HealthLeftTarget = ( XUB.LastDamageTarget / healthDiff ) * UnitHealth("target");
					if ( XUB.HealthLeftTarget > (-myButton.Threshold) ) then
						myButton.is_STATE_HEALTHOFF = 1;
					end
				else
					myButton.is_STATE_HEALTHOFF = 1;
				end
			else
				myButton.is_STATE_HEALTHOFF = 1;
			end
		end
	else
		myButton.is_STATE_INVALID = 1;
	end


end


function  XUB_CheckSpellCondition(myButton)

	if ( XUB.AllBuffs2[string.lower(myButton.FullSpellName)] ) then
		myButton.is_STATE_BUFFED = 1;
		return;
	end  
end

