﻿local addonName, XUB = ...;

function XUB_Check_for_Changes()

	-- XUB_ShowDebugMessage("XUB: Starting Check for Changes")
	-- no finish for this start, because it's all handled by returns

	if ( InCombatLockdown() ) then
		XUB_ShowDebugMessage("XUB-debug: Changes can not be applied while in Combat, but they will be applied after combat");
		XUB.ChangesToBeApplyAfterCombat = XUB.CurrentProfile;
		--XUB_ShowMessage("ProfileChange: " ..CCC(XUB.ProfileChange).."  Spells: "..CCC(XUB.LEARNED_SPELL_IN_TAB).."  Raid: "..CCC(XUB.RAID_ROSTER_UPDATE).."  Party: "..CCC(XUB.PARTY_MEMBERS_CHANGED))
		return;
	end

	if ( XUB.ProfileChange > 0) then
		XUB.ProfileChange = 0;
		XUB.manualChange = 1;
		if ( XUB.ChangesToBeApplyAfterCombat ) then
			XUB_ShowDebugMessage("XUB: Combat finished - delayed changes will be applied now");
			XUB_ApplyProfile(XUB.ChangesToBeApplyAfterCombat);
		else
			XUB_ShowDebugMessage("XUB: Starting apply because of a profile change (user action)")
			XUB_ApplyProfile(XUB.CurrentProfile);
		end
		return;
	end

	if ( XUB.LEARNED_SPELL_IN_TAB > 0) then
		XUB_ShowDebugMessage("XUB-debug: Starting apply because of a spell or spec change")
		XUB.LEARNED_SPELL_IN_TAB = 0;
		XUB_ReCheck_ButtonInfo()
		XUB.manualChange = nil;
		XUB_ApplyProfile(XUB.CurrentProfile);
		return;
	end

	if  ( XUB.RAID_ROSTER_UPDATE > 0 ) then
		XUB.manualChange = nil;
		XUB.RAID_ROSTER_UPDATE = 0;
		XUB_ShowDebugMessage("XUB-debug: Starting check because of a raid change")
		XUB_Check_for_GroupChanges();
		return;
	end

	if ( XUB.PARTY_MEMBERS_CHANGED > 0) then
		XUB.manualChange = nil;
		XUB.PARTY_MEMBERS_CHANGED = 0;
		XUB_ShowDebugMessage("XUB-debug: Starting check because of a party change")
		XUB_Check_for_GroupChanges();
		return;
	end

	XUB_ShowDebugMessage("XUB: Why the hell are we here ??? ")

end


function XUB_Check_for_GroupChanges()

	local changesApplied = nil
	local myOldFrameTable = nil;

	XUB.manualChange = nil;
	XUB.Busy = 1;
	
	if ( GetNumRaidMembers() > 0 ) then 			-- player is in a raid
		XUB_ShowDebugMessage("XUB-debug: going to check for RaidChanges")
		XUB.GroupType = "raid";
		XUB_ShowDebugMessage("XUB.RaidUnitframesConfigured: " .. CCC(XUB.RaidUnitframesConfigured))
		XUB_ShowDebugMessage("XUB.ShowPartyInRaid: " .. CCC(XUB.ShowPartyInRaid))
		if XUB.RaidUnitframesConfigured then
			myOldFrameTable = XUB.RaidFrameTable
			XUB_Initialize_RaidFrameTable()
			changesApplied = XUB_Check_for_GroupChanges2(myOldFrameTable, XUB.RaidFrameTable);
		else
			XUB.RaidFrameTable = {}
		end	
		if ( XUB.ShowPartyInRaid ) then
			XUB_ShowDebugMessage("XUB-debug: going to check for PartyChanges because 'XUB.ShowPartyInRaid' was set")
			myOldFrameTable = XUB.PartyFrameTable;
			XUB_Initialize_PartyFrameTable()
			local partyChangesApplied = XUB_Check_for_GroupChanges2(myOldFrameTable, XUB.PartyFrameTable);
			changesApplied = changesApplied or partyChangesApplied
		else		--remove the group buttons   
			for unitName,frameName in pairs(XUB.PartyFrameTable) do 
				XUB_RemoveButtons_for_SingleUnit(unitName,nil);     -- let's remove all party buttons
			end
			XUB.PartyFrameTable = {}
		end
	elseif ( GetNumPartyMembers() > 0 ) then 	-- player is in a party
		XUB.GroupType = "party";
		if ( #XUB.RaidFrameTable > 0) then                 -- if the player was in a raid, but is now in a party
			XUB_ShowDebugMessage("XUB-debug: Applying profile because of a change from raid to party")
			XUB.RaidFrameTable = {};
			XUB_ApplyProfile(XUB.CurrentProfile);
			changesApplied = true;
		else
			XUB_ShowDebugMessage("XUB-debug: going to check for PartyChanges")
			myOldFrameTable = XUB.PartyFrameTable;
			XUB_Initialize_PartyFrameTable()
			changesApplied = XUB_Check_for_GroupChanges2(myOldFrameTable, XUB.PartyFrameTable);
		end
	else
		-- player is playing solo
		XUB.GroupType = "solo"
		XUB_ShowDebugMessage("XUB-debug: Starting apply because player is now playing solo again")
		XUB_ApplyProfile(XUB.CurrentProfile);
		return;
	end


	if ( changesApplied ) then
		XUB_ShowDebugMessage("XUB: Applied because grouptype has changed to '" .. XUB.GroupType .. "'")
	end

	XUB.Busy = 0;

end


function XUB_Check_for_GroupChanges2(myOldFrameTable, myCompareFrameTable)

	XUB_ShowDebugMessage("XUB-debug: Starting Check_for_GroupChanges2")
	local changesApplied = nil

	if ( #myCompareFrameTable < #myOldFrameTable ) then           -- members have been REMOVED
		for i=#MyOldParty,#myCompareFrameTable+1,-1 do
			XUB_RemoveButtons_for_SingleUnit(myCompareFrameTable[i],nil);     -- let's remove surplus buttons
		end
		changesApplied = true;
	end

	for unitName,frameName in pairs(myCompareFrameTable) do
		if myCompareFrameTable[unitName] ~= myOldFrameTable[unitName] then 	-- frames for member 'unitName' have changed
--			if myOldFrameTable[unitName] then 							-- if there was a frame before
				XUB_RemoveButtons_for_SingleUnit(unitName,nil); 			-- let's remove the buttons that have changed
--			end
			XUB_ApplyProfile_for_SingleUnit(XUB.CurrentProfile, unitName);
			changesApplied = true;
		end
	end

	XUB_ShowDebugMessage("XUB-debug: Finished Check_for_GroupChanges2")
	return changesApplied;
end

