﻿local addonName, XUB = ...;

function XUB_ConvertSaved()

	XUB_ShowDebugMessage("XUB: ConvertSaved started");
	
	if (XUB_ConversionLevel == nil) or (XUB_ConversionLevel =="") then
		XUB_ConversionLevel = 2.0
	end    
	
	if XUB_ConversionLevel < 2.0 then
		return;		-- NO CONVERSION OF PreCataclysm configurations, sorry
	end

	--Copy Saved Variables into a local table (shared for the whole addon)
	-- alphabetical
	XUB.ANCHOR = XUB_ANCHOR or XUB.ANCHOR 
	XUB.BLINKRATE = XUB_BLINKRATE or XUB.BLINKRATE 
	XUB.BUFFED_ALPHA = XUB_BUFFED_ALPHA or XUB.BUFFED_ALPHA 
	XUB.BUTTON_SPACING = XUB_BUTTON_SPACING or XUB.BUTTON_SPACING 
	XUB.CHANGEDELAY = XUB_CHANGEDELAY or XUB.CHANGEDELAY 
	XUB.COLORUSAGE = XUB_COLORUSAGE or XUB.COLORUSAGE 
	XUB.CustomButtons = XUB_CustomButtons or XUB.CustomButtons 
	XUB.ConfigGroups = XUB_ConfigGroups or XUB.ConfigGroups 
	XUB.ConfigProfiles = XUB_ConfigProfiles or XUB.ConfigProfiles 
	XUB.COOLDOWN_ALPHA = XUB_COOLDOWN_ALPHA or XUB.COOLDOWN_ALPHA 
	XUB.COUNTDOWN = XUB_COUNTDOWN or XUB.COUNTDOWN 
	XUB.CurrentProfile = XUB_CurrentProfile or XUB.CurrentProfile 
	XUB.ENABLE_ALPHA = XUB_ENABLE_ALPHA or XUB.ENABLE_ALPHA 
	XUB.GROUPSPACING = XUB_GROUPSPACING or XUB.GROUPSPACING 
	XUB.HEALACTION = XUB_HEALACTION or XUB.HEALACTION 
	XUB.INVALID_ALPHA = XUB_INVALID_ALPHA or XUB.INVALID_ALPHA 
	XUB.NOMANA_ALPHA = XUB_NOMANA_ALPHA or XUB.NOMANA_ALPHA 
	XUB.OUTOFRANGE_ALPHA = XUB_OUTOFRANGE_ALPHA or XUB.OUTOFRANGE_ALPHA 
	XUB.QUEUESIZE = XUB_QUEUESIZE or XUB.QUEUESIZE 
	XUB.ShowDecimals = XUB_ShowDecimals or XUB.ShowDecimals 
	XUB.ShowPartyInRaid = XUB_ShowPartyInRaid or XUB.ShowPartyInRaid 
	XUB.TOOLTIPS = XUB_TOOLTIPS or XUB.TOOLTIPS 
	XUB.UF_UnitFrameAddon = XUB_UF_UnitFrameAddon or XUB.UF_UnitFrameAddon 
	XUB.RF_RaidFrameAddon = XUB_RF_RaidFrameAddon or XUB.RF_RaidFrameAddon 
	XUB.UF_WIDTH_Float = XUB_UF_WIDTH_Float or XUB.UF_WIDTH_Float
	XUB.UPDATERATE = XUB_UPDATERATE or XUB.UPDATERATE 
	XUB.USE_BUILTIN_COOLDOWN = XUB_USE_BUILTIN_COOLDOWN or XUB.USE_BUILTIN_COOLDOWN 
	XUB.USE_GLOBALDIM = XUB_USE_GLOBALDIM or XUB.USE_GLOBALDIM 
	XUB.Use_RightButton = XUB_Use_RightButton or XUB.Use_RightButton 
	XUB.Use_MiddleButton = XUB_Use_MiddleButton or XUB.Use_MiddleButton 
	XUB.Use_Button4 = XUB_Use_Button4 or XUB.Use_Button4 
	XUB.Use_Button5 = XUB_Use_Button5 or XUB.Use_Button5
	XUB.Profile_for_Spec = XUB_Profile_for_Spec or XUB.Profile_for_Spec
	
	XUB.UF= XUB_UF or XUB.UF
	XUB.RF= XUB_RF or XUB.RF
	
	XUB.RaidUnitframesConfigured = 1;
	if ( XUB.RF_RaidFrameAddon == "no raid buttons") then
		XUB.RaidUnitframesConfigured = nil;
	end


	-- prepare the SavedVariables to be garbage collected
	XUB_ANCHOR = nil
	XUB_BLINKRATE = nil
	XUB_BUFFED_ALPHA = nil
	XUB_BUTTON_SPACING = nil
	XUB_CHANGEDELAY = nil
	XUB_COLORUSAGE = nil
	XUB_CustomButtons = nil
	XUB_ConfigGroups = nil
	XUB_ConfigProfiles = nil
	XUB_ConversionLevel = nil
	XUB_COOLDOWN_ALPHA = nil
	XUB_COUNTDOWN = nil
	XUB_CurrentProfile = nil
	XUB_ENABLE_ALPHA = nil
	XUB_GROUPSPACING = nil
	XUB_HEALACTION = nil
	XUB_INVALID_ALPHA = nil
	XUB_NOMANA_ALPHA = nil
	XUB_OUTOFRANGE_ALPHA = nil
	XUB_QUEUESIZE = nil
	XUB_ShowDecimals = nil
	XUB_ShowPartyInRaid = nil
	XUB_TOOLTIPS = nil
	XUB_UF_UnitFrameAddon = nil
	XUB_UF = nil
	XUB_RF = nil
	XUB_RF_RaidFrameAddon = nil
	XUB_UF_WIDTH_Float = nil
	XUB_UPDATERATE = nil
	XUB_USE_BUILTIN_COOLDOWN = nil
	XUB_Use_Button4 = nil
	XUB_Use_Button5 = nil
	XUB_USE_GLOBALDIM = nil
	XUB_Use_MiddleButton = nil
	XUB_Use_RightButton = nil
	XUB_Profile_for_Spec = nil

XUB_ShowDebugMessage("XUB: ConvertSaved finished");

end


function XUB_SavedVariables_local2Global()

	XUB_ANCHOR = XUB.ANCHOR
	XUB_BLINKRATE = XUB.BLINKRATE
	XUB_BUFFED_ALPHA = XUB.BUFFED_ALPHA
	XUB_BUTTON_SPACING = XUB.BUTTON_SPACING
	XUB_CHANGEDELAY = XUB.CHANGEDELAY
	XUB_COLORUSAGE = XUB.COLORUSAGE
	XUB_CustomButtons = XUB.CustomButtons
	XUB_ConfigGroups = XUB.ConfigGroups
	XUB_ConfigProfiles = XUB.ConfigProfiles
	XUB_ConversionLevel = 2.00
	XUB_COOLDOWN_ALPHA = XUB.COOLDOWN_ALPHA
	XUB_COUNTDOWN = XUB.COUNTDOWN
	XUB_CurrentProfile = XUB.CurrentProfile
	XUB_ENABLE_ALPHA = XUB.ENABLE_ALPHA
	XUB_GROUPSPACING = XUB.GROUPSPACING
	XUB_HEALACTION = XUB.HEALACTION
	XUB_INVALID_ALPHA = XUB.INVALID_ALPHA
	XUB_NOMANA_ALPHA = XUB.NOMANA_ALPHA
	XUB_OUTOFRANGE_ALPHA = XUB.OUTOFRANGE_ALPHA
	XUB_QUEUESIZE = XUB.QUEUESIZE
	XUB_ShowDecimals = XUB.ShowDecimals
	XUB_ShowPartyInRaid = XUB.ShowPartyInRaid
	XUB_TOOLTIPS = XUB.TOOLTIPS
	XUB_UF = XUB.UF
	XUB_RF = XUB.RF
	XUB_UF_UnitFrameAddon = XUB.UF_UnitFrameAddon
	XUB_RF_RaidFrameAddon = XUB.RF_RaidFrameAddon
	XUB_UF_WIDTH_Float = XUB.UF_WIDTH_Float
	XUB_UPDATERATE = XUB.UPDATERATE
	XUB_USE_BUILTIN_COOLDOWN = XUB.USE_BUILTIN_COOLDOWN
	XUB_USE_GLOBALDIM = XUB.USE_GLOBALDIM
	XUB_Use_RightButton = XUB.Use_RightButton
	XUB_Use_MiddleButton = XUB.Use_MiddleButton
	XUB_Use_Button4 = XUB.Use_Button4
	XUB_Use_Button5 = XUB.Use_Button5
	XUB_Profile_for_Spec = XUB.Profile_for_Spec

end

