local addonName, XUB = ...;

function XUB_DumpSpellList()
	local i = 1
	local spellName, subSpellName
	while true do
		spellName, subSpellName = GetSpellInfo(i, BOOKTYPE_SPELL)
		if not spellName then
			do break end
		end

		-- use spellName and subSpellName here
		DEFAULT_CHAT_FRAME:AddMessage( spellName .. '(' .. subSpellName .. ')' )

		i = i + 1
	end
end

function Debug(aWhat , aMessage)
	if XUB.DEBUG > 0 then
		if ( aMessage == nil ) then
			DEFAULT_CHAT_FRAME:AddMessage( aWhat .. " = NIL" );
		else
			DEFAULT_CHAT_FRAME:AddMessage( aWhat .. " = >" .. aMessage .. "<" );
		end
	end
end

function N(aArg)
	if ( aArg == nil ) then
		return "nil";
	else
		return aArg;
	end
end

function CCC(aArg)

-- possible type:
--nil, boolean, number, string, userdata, function, thread, and table

	if ( aArg == nil ) then
		return "'nil'";
	elseif type(aArg) == "table" then
		return "'a table'"
	elseif type(aArg) == "function" then
		return "'a function'"
	elseif ( aArg == true ) then
		return "'true'";
	elseif ( aArg == false ) then
		return "'false'";
	else
		return "'" .. aArg .. "'";
	end
end

function DumpTable(aTable)
	for i=1,#aTable do
		XUB_ShowDebugMessage("Index: "..i.." Value: "..CCC(aTable[i]));
	end
end

function XUB_ShowDebugMessage(MyString)
	if XUB.DEBUG >0 then
			XUB_ShowMessage(MyString);
	end
end

function XUB_Show_DebugBlock1(myButton, i, aUnit)
	if ( i==1 ) then
		XUB_ShowDebugMessage( "     ");
		XUB_ShowDebugMessage( "currently updated unit (aUnit): " .. aUnit );
	end
	XUB_ShowDebugMessage( "Buttonname : '" .. XUB_GenerateButtonName(aUnit,i) .. "'      FullSpellName: '" .. myButton.FullSpellName .. "'" )
end

function XUB_Show_DebugBlock2(myButton, i, aUnit, myPreviousState)

	XUB_ShowMessage( "currently updated unit (aUnit): " .. aUnit .. "           Buttonname : '" .. XUB_GenerateButtonName(aUnit,i) .. "'" )
	XUB_ShowMessage("myButton.PreviousState: "..myPreviousState.."   myButton.State: "..myButton.State);
	if myButton.Blink > 0 then
		XUB_ShowMessage("myButton.Blink: " .. myButton.Blink );
	end
	if myButton.MyCooldown > 0 then
		XUB_ShowMessage("myButton.MyCooldown: " .. myButton.MyCooldown );
	end
	XUB_ShowMessage("  ");
end

function XUB_Add_DebugTooltip(myButton)
-- Show additional information in the tooltip if debugging is ON

	XUB_GameTooltip:AddLine("   ",1,1,1,0);
	XUB_GameTooltip:AddLine("XUB-DebugData:",1,1,1,1);
	XUB_GameTooltip:AddLine(" State: "..myButton.State,1,1,0,0);
	XUB_GameTooltip:AddLine(" Attached to frame: "..myButton.AttachedFrame,1,1,0,1);

	local l_mainDestinationUnit = myButton.DestinationUnit
	if ( myButton.Multitarget~= "" ) then
		l_mainDestinationUnit = myButton.Multitarget
	end
	XUB_GameTooltip:AddLine(" Destination unit: "..l_mainDestinationUnit,1,1,0,1);
	if myButton.FullSpellName then XUB_GameTooltip:AddLine(" Fullspellname: "..myButton.FullSpellName,1,1,0,1); end;
	if myButton.global_ID > 0 then XUB_GameTooltip:AddLine(" XUB Global ID: "..CCC(myButton.global_ID),1,1,0,1); end;
	if myButton.ExtraType then
		XUB_GameTooltip:AddLine(" ButtonType: " .. myButton.ExtraType,1,1,0,1);
	else
		XUB_GameTooltip:AddLine(" ButtonType: Spell",1,1,0,1);
	end
	if myButton.Blink > 0 then
		XUB_GameTooltip:AddLine(" myButton.Blink: " .. myButton.Blink,1,1,0,1);
	end
	XUB_GameTooltip:AddLine("   ",0,1,1,0);
	--GameTooltip:AddLine(" myButton.isDebuff: " .. myButton.isDebuff,1,1,0,1);
	--GameTooltip:AddLine(" myButton.isBuff: " .. myButton.isBuff,1,1,0,1);
	if myButton.SpecialLastSeconds then
		XUB_GameTooltip:AddLine(" Last X seconds are handled specially: " .. myButton.SpecialLastSeconds,1,1,0,1);
	end
	if myButton.LastsTill then
		XUB_GameTooltip:AddLine(" Remaining Seconds for Buff: " .. myButton.LastsTill,1,1,0,1);
	end

	if myButton.State == 0         then XUB_GameTooltip:AddLine(" Button is fully enabled"); end
	if myButton.is_STATE_HEALTHOFF  then XUB_GameTooltip:AddLine(" STATE_HEALTHOFF = 1"); end
	if myButton.is_STATE_BUFFED     then XUB_GameTooltip:AddLine(" STATE_BUFFED = 1"); end
	if myButton.is_STATE_DIMMED     then XUB_GameTooltip:AddLine(" STATE_DIMMED = 1"); end
	if myButton.is_STATE_COOLDOWN   then XUB_GameTooltip:AddLine(" STATE_COOLDOWN = 1"); end
	if myButton.is_STATE_NO_ITEMS   then XUB_GameTooltip:AddLine(" STATE_NO_ITEMS = 1"); end
	if myButton.is_STATE_OUTOFMANA  then XUB_GameTooltip:AddLine(" STATE_OUTOFMANA = 1"); end
	if myButton.is_STATE_OUTOFRANGE then XUB_GameTooltip:AddLine(" STATE_OUTOFRANGE = 1"); end
	if myButton.is_STATE_INVALID    then XUB_GameTooltip:AddLine(" STATE_INVALID = 1"); end

end

function XUB_TestMyTable(myTable,myText)
	if myText then XUB_ShowMessage("at: "..myText); end
	for i,v in pairs(myTable) do
		XUB_ShowMessage("+>: "..i.." = "..CCC(v))
		if type(v) == "table" then
			for ii,vv in pairs(v) do
				XUB_ShowMessage("+++>: "..ii.." = "..CCC(vv))
				if type(vv) == "table" then
					for iii,vvv in pairs(vv) do
						XUB_ShowMessage("+++++++>: "..iii.." = "..CCC(vvv))
					end		
				end
			end		
		end
	end
end
