﻿local addonName, XUB = ...;

function XUB_DoFirstInitialisation()

-- 	XUB_ShowDebugMessage("XUB-debug: First initialisation started");

--	XUB_Fill_ConfigEditBoxes_with_Text()

	XUB_InitialiseProfileNames()
	
	XUB_ReCheck_ButtonInfo()

-- 	XUB_Initialize_CountdownFont();

	-- Setup the slash commands

	SLASH_XUB1 = "/XUB";
	SLASH_XUB2 = "/xub";
	SlashCmdList["XUB"] = function(msg)
		XUB_SlashCommandHandler(msg);
	end

	if XUB.Profile_for_Spec[GetActiveTalentGroup()] and XUB.Profile_for_Spec[GetActiveTalentGroup()] ~= "" then
		XUB.CurrentProfile = XUB.Profile_for_Spec[GetActiveTalentGroup()]
	end
	
	if ( XUB.CurrentProfile ~= "" ) then
		XUB_ApplyProfile(XUB.CurrentProfile);
	else
		XUB_ShowMessage("XUB has not been configured yet.")
		XUB_ShowMessage("    Please make a config by entering  /XUB config");
		return;
	end

	PBFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
	PBFrame:RegisterEvent("PARTY_MEMBERS_CHANGED");
	PBFrame:RegisterEvent("RAID_ROSTER_UPDATE");
	PBFrame:RegisterEvent("PARTY_CONVERTED_TO_RAID");
	PBFrame:RegisterEvent("LEARNED_SPELL_IN_TAB");
	PBFrame:RegisterEvent("SPELLS_CHANGED");
	PBFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	PBFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
	
	PBFrame:RegisterEvent("UNIT_ENTERED_VEHICLE");
	--PBFrame:RegisterEvent("UNIT_ENTERING_VEHICLE");
	--PBFrame:RegisterEvent("UNIT_EXITING_VEHICLE");
	PBFrame:RegisterEvent("UNIT_EXITED_VEHICLE");
	
	if ( XUB.USE_GLOBALDIM == 1 ) then
		PBFrame:RegisterEvent("UNIT_SPELLCAST_START");
	end

	XUB_ShowMessage( GetAddOnMetadata("eXtremeUnitButtons","Title") .. " Version " .. GetAddOnMetadata("eXtremeUnitButtons","Version") .. " Loaded (/XUB - for options)" )

-- 	XUB_ShowDebugMessage("XUB-debug: First initialisation finished");

end


function XUB_Initialize_Membertables(myCurrentProfileInfo)

	XUB.RaidFrameTable = {}
	XUB.PartyFrameTable = {}
	XUB.ArenaFrameTable = {}
	local raidConfigured, partyConfigured, arenaConfigured
	local myTempTable = {}

	XUB.ConfiguredUnits = {}

	-- here we create a new table that contains all units that are configured in the current profile config
	for i=1,#myCurrentProfileInfo do
		myTempTable[myCurrentProfileInfo[i].attachUnit] = 1
	end

	for attachUnit in pairs(myTempTable) do
		if attachUnit == "raid" then
			if XUB.RaidUnitframesConfigured then			-- if there are unitframes for raid configured
				for ii=1,GetNumRaidMembers() do
					table.insert(XUB.ConfiguredUnits,attachUnit..ii)
					raidConfigured = 1
				end
			else
				-- do nothing here
			end
		elseif (attachUnit == "partypet") or (attachUnit == "party") then
			for ii=1,GetNumPartyMembers() do
--			for ii=1,5 do
				table.insert(XUB.ConfiguredUnits,attachUnit..ii)
				partyConfigured = 1
			end
		elseif attachUnit == "arena" then
--			if GetCVarBool("showArenaEnemyFrames") then
				for ii=1,GetNumArenaOpponents() do
					table.insert(XUB.ConfiguredUnits,attachUnit..ii)
					arenaConfigured = 1
				end
--			end
		elseif attachUnit == "float" then
			XUB.FloatConfigured = 1
			table.insert(XUB.ConfiguredUnits,attachUnit)
		else	-- single unit
			table.insert(XUB.ConfiguredUnits,attachUnit)
		end
	end


	
	if raidConfigured then
		XUB_Initialize_RaidFrameTable();
	end
	if partyConfigured then
		XUB_Initialize_PartyFrameTable();
		if XUB.PartyFrameTable["player_in_party"] then
			table.insert(XUB.ConfiguredUnits, "player_in_party" )
		end
		if XUB.PartyFrameTable["playerpet_in_party"] then
			table.insert(XUB.ConfiguredUnits, "playerpet_in_party" )
		end
	end
	if arenaConfigured then
		XUB_Initialize_ArenaFrameTable();
	end
end

function XUB_GetPartyFrame(i,myFrameInfo)

	local testFrameName , testUnitName , testFrame , testFrameUnit ;

	testFrameName = myFrameInfo
	testFrameName = testFrameName:gsub("!!","0" .. i):gsub("!",i):gsub("#",i):gsub("@",1);
	testFrame = getglobal(testFrameName);
	if ( testFrame ) then
		testFrameUnit = testFrame:GetAttribute("unit");
		if ( testFrameUnit ) then
			if ( testFrameUnit == "player") then
				testFrameUnit = "player_in_party"
			end
			if ( testFrameUnit == "pet") then
				testFrameUnit = "playerpet_in_party"
			end
			if ( XUB.PartyFrameTable[testFrameUnit] ~= nil ) then
				XUB.PartyFrameTable[testFrameUnit] = XUB.PartyFrameTable[testFrameUnit] .. "/" .. testFrameName;
			else
				XUB.PartyFrameTable[testFrameUnit] = testFrameName;
			end
			XUB_ShowDebugMessage("XUB_GetPartyFrame: "..CCC(i).." | "..CCC(testFrameName).." | "..CCC(testFrameUnit) )
		end
	end
end


function XUB_Initialize_PartyFrameTable()

	XUB.PartyFrameTable = {}

	if ( GetNumPartyMembers() > 0 ) then
		XUB_ShowDebugMessage("XUB-debug: Starting XUB_InitializePartyFrameTable()");
		
		for i=1,GetNumPartyMembers()+1 do
--		for i=1,5 do
			XUB_GetPartyFrame(i,XUB.UF["Party"].frame)
			XUB_GetPartyFrame(i,XUB.UF["PartyPet"].frame)
		end
		
		XUB_ShowDebugMessage("XUB-debug: Finished XUB_InitializePartyFrameTable()");
	end
end


function XUB_Initialize_RaidFrameTable()

	XUB.RaidFrameTable = {}

	if ( GetNumRaidMembers() > 0 ) then
		local testFrameName, testFrame, testFrameUnit;
	
		XUB_ShowDebugMessage("XUB-debug: Starting XUB_Initialize_RaidFrameTable()");
	
		if ( XUB.RF_RaidFrameAdon == "CTRaid" ) then
			if ( CT_RA_UnitIDFrameMap ) then
				for r=1,GetNumRaidMembers() do
					testFrame = CT_RA_UnitIDFrameMap["raid" .. r]
					if ( testFrame ) then
						XUB.RaidFrameTable["raid" .. r] = testFrame.name;
					end
				end
			end
		elseif ( XUB.RF_RaidFrameAdon == "XPerl" ) then
			if ( XPERL_RAIDGRP_PREFIX ) and (XPerl_Raid_OnLoad == nil) and (XPerl_Raid_GetUnitFrameByUnit) then
				for i = 1,GetNumRaidMembers() do
					testFrame = XPerl_Raid_GetUnitFrameByUnit("raid"..i);
					if ( testFrame ) then
						XUB.RaidFrameTable["raid" .. i] = testFrame:GetName();
					end
				end
			end
		elseif ( XUB.RF_RaidFrameAddon == "no raid buttons" ) then
			-- do nothing
		else
			local max_groups = 1;
			local max_units = 1;
	
			if string.find(XUB.RF["RaidMember"].frame,"@") then
				max_groups = 25;
			end
			if string.find(XUB.RF["RaidMember"].frame,"#") then
				max_units = 25;
			end
	
			for g=1,max_groups do
				for u=1,max_units do
					testFrameName = XUB.RF["RaidMember"].frame
					testFrameName = testFrameName:gsub("@",g):gsub("#",u);
					testFrame = getglobal(testFrameName);
					if ( testFrame ) then
				--XUB_ShowMessage("XUB-debug: u: "..u.."   g: " .. g.."  max_groups: " .. max_groups.."  max_units: "..max_units);
						testFrameUnit = testFrame:GetAttribute("unit");
						if ( testFrameUnit ~= nil ) then
							if ( XUB.RaidFrameTable[testFrameUnit] ~= nil ) then
								XUB.RaidFrameTable[testFrameUnit] = XUB.RaidFrameTable[testFrameUnit] .. "/" .. testFrameName;
							else
								XUB.RaidFrameTable[testFrameUnit] = testFrameName;
							end
						end
					else
						break;
					end
				end
			end
		end  
		XUB_ShowDebugMessage("XUB-debug: Finished XUB_Initialize_RaidFrameTable()");
	end

end

function XUB_Initialize_ArenaFrameTable()

	XUB.ArenaFrameTable = {};
	
	for i =1,GetNumArenaOpponents() do
		testFrameName = XUB.RF["Arena"].frame
		testFrameName = testFrameName:gsub("#",i);
		testFrame = getglobal(testFrameName);
		if ( testFrame ) then
			testFrameUnit = testFrame:GetAttribute("unit");
			if ( testFrameUnit ~= nil ) then
				if ( XUB.RaidFrameTable[testFrameUnit] ~= nil ) then
					XUB.RaidFrameTable[testFrameUnit] = XUB.RaidFrameTable[testFrameUnit] .. "/" .. testFrameName;
				else
					XUB.RaidFrameTable[testFrameUnit] = testFrameName;
				end
			end
		end
	end

	XUB_ShowDebugMessage("XUB-debug: Finished XUB_Initialize_ArenaFrameTable()");

end
