﻿local addonName, XUB = ...;

local LDB_XUB = LibStub("LibDataBroker-1.1"):NewDataObject("eXtremeUnitButtons", {
--	type = "launcher",
	type = "data source",
	icon = "Interface\\Icons\\Spell_ChargePositive",
	OnClick = function(clickedframe, button)
		if button == "RightButton" then 
			XUB_LDB_MouseClick(clickedframe)
		else
			XUB.manualChange = 1;
			XUB_ApplyProfile(XUB.CurrentProfile)
		end
	end,
	OnTooltipShow = function(tt)
		tt:AddLine("eXtreme Unit Buttons")
		tt:AddLine("|cffffff00" .. "Click|r to reapply the current profile")
		tt:AddLine("|cffffff00" .. "Right-click|r to open a menu")
	end,
})

function XUB_LDB_MouseClick(clickedframe)
	XUB.LDB_Menu.scale = UIParent:GetScale()
	GameTooltip:Hide()
	ToggleDropDownMenu( nil, nil, XUB.LDB_Menu, clickedframe , 0, 0)
end

function XUB_LDB_Menu()

	local info = {}

	for i=1,#XUB.profileNames do
		info.text = "Switch profile to "..CCC(XUB.profileNames[i])
		info.value = XUB.profileNames[i]
		info.disabled = false
		info.func = function() XUB_LDB_MenuChoice(i); end
		UIDropDownMenu_AddButton(info); 
	end

	info.text = ""
	info.value = ""
	info.disabled = true
	UIDropDownMenu_AddButton(info); 

	info.text = "Open Config"
	info.value = "Open Config"
	info.disabled = false
	info.func = function() XUB_Config_Open(); end
	UIDropDownMenu_AddButton(info); 
end

function XUB_LDB_MenuChoice(userChoice)
	XUB.manualChange = 1;
	XUB_ApplyProfile(XUB.profileNames[userChoice])
end
