﻿local addonName, XUB = ...;


function XUB_Options_Open()
	XUB_PrepareOptionVariables();
	XUB_Options:Show();
end        

function XUB_Options_Save()
	XUB_RefreshOptionVariables();
	XUB.manualChange = 1;
	XUB_ApplyProfile(XUB.CurrentProfile);
end        

function XUB_RefreshOptionVariables()

	XUB.ANCHOR = XUB_Options_FirstButtonAnchorText:GetText();
	XUB.BUTTON_SPACING = XUB_Options_ButtonSpacingSlider:GetValue();
	XUB.UPDATERATE = XUB_Options_UpdateRateSlider:GetValue();
	XUB.GROUPSPACING = XUB_Options_GroupSpacingSlider:GetValue();

	XUB.ENABLE_ALPHA = XUB_Options_EnabledSlider:GetValue();
	XUB.BUFFED_ALPHA = XUB_Options_BuffedSlider:GetValue();
	XUB.COOLDOWN_ALPHA = XUB_Options_CooldownSlider:GetValue();
	XUB.NOMANA_ALPHA = XUB_Options_OutOfManaSlider:GetValue();
	XUB.OUTOFRANGE_ALPHA = XUB_Options_OutOfRangeSlider:GetValue();
	XUB.INVALID_ALPHA = XUB_Options_FarOutOfRangeSlider:GetValue();

	XUB.BLINKRATE = XUB_Options_BlinkRateSlider:GetValue();

	XUB.TOOLTIPS = XUB_Options_ToolTipOptionText:GetText();

	XUB.COLORUSAGE = XUB_Options_ColorUsageText:GetText();

	XUB.HEALACTION = XUB_Options_HealActionText:GetText();
	
	XUB.QUEUESIZE = XUB_Options_RefreshQueueSizeSlider:GetValue();
	XUB.CHANGEDELAY = XUB_Options_ChangeDelaySlider:GetValue();
	
	if ( XUB_Options_Countdown:GetChecked() ) then
		XUB.COUNTDOWN = 1;
	else
		XUB.COUNTDOWN = 0;
	end
	
	if ( XUB_Options_CooldownSpinner:GetChecked() ) then
		XUB.USE_BUILTIN_COOLDOWN = 1;
	else
		XUB.USE_BUILTIN_COOLDOWN = 0;
	end
	
	if ( XUB_Options_GlobalDim:GetChecked() ) then
		XUB.USE_GLOBALDIM = 1;
		PBFrame:RegisterEvent("UNIT_SPELLCAST_START");
		XUB_ShowMessage("Been here 1");
	else
		XUB.USE_GLOBALDIM = 0;
		PBFrame:UnregisterEvent("UNIT_SPELLCAST_START");
		PBFrame:UnregisterEvent("UNIT_SPELLCAST_STOP");
		PBFrame:UnregisterEvent("UNIT_SPELLCAST_FAILED");
		PBFrame:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
		PBFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	end
	
	if ( XUB_Options_ShowDecimalValues:GetChecked() ) then
		XUB.ShowDecimals = 1;
	else
		XUB.ShowDecimals = nil;
	end
		
end

function XUB_PrepareOptionVariables()

	XUB_Options_ButtonSpacingSlider:SetValue(XUB.BUTTON_SPACING);
	XUB_Options_UpdateRateSlider:SetValue(XUB.UPDATERATE);
	XUB_Options_GroupSpacingSlider:SetValue(XUB.GROUPSPACING);

	XUB_Options_EnabledSlider:SetValue(XUB.ENABLE_ALPHA);
	XUB_Options_BuffedSlider:SetValue(XUB.BUFFED_ALPHA);
	XUB_Options_CooldownSlider:SetValue(XUB.COOLDOWN_ALPHA);
	XUB_Options_OutOfManaSlider:SetValue(XUB.NOMANA_ALPHA);
	XUB_Options_OutOfRangeSlider:SetValue(XUB.OUTOFRANGE_ALPHA);
	XUB_Options_FarOutOfRangeSlider:SetValue(XUB.INVALID_ALPHA);

	XUB_Options_BlinkRateSlider:SetValue(XUB.BLINKRATE);

	XUB_Options_FirstButtonAnchorText:SetText(XUB.ANCHOR);

	XUB_Options_RefreshQueueSizeSlider:SetValue(XUB.QUEUESIZE);
	XUB_Options_ChangeDelaySlider:SetValue(XUB.CHANGEDELAY);

	if ( XUB.TOOLTIPS == nil ) then
		XUB.TOOLTIPS = "Always";
	end

	XUB_Options_ToolTipOptionText:SetText(XUB.TOOLTIPS);

	if ( XUB.COLORUSAGE == nil ) then
		XUB.COLORUSAGE = "Transparency";
	end
	XUB_Options_ColorUsageText:SetText(XUB.COLORUSAGE);

	if ( XUB.HEALACTION == nil ) then
		XUB.HEALACTION = "Show as Disabled";
	end
	XUB_Options_HealActionText:SetText(XUB.HEALACTION);
	
	XUB_Options_Countdown:SetChecked(XUB.COUNTDOWN);
	
	XUB_Options_CooldownSpinner:SetChecked(XUB.USE_BUILTIN_COOLDOWN);
	
	XUB_Options_GlobalDim:SetChecked(XUB.USE_GLOBALDIM);
	
	XUB_Options_ShowDecimalValues:SetChecked(XUB.ShowDecimals);

end


-- XUB_Percent( XUB_Options_AlphaEnabledSlider , XUB_Options_Label_AlphaEnabledLabel );
function XUB_SliderPercent(aSlider)

	local s = getglobal( "XUB_Options_" .. aSlider .. "Slider" );
	local l = getglobal( "XUB_Options_Label_" .. aSlider .. "Label" );
	local high = getglobal( "XUB_Options_" .. aSlider .. "SliderHigh" );
	local low = getglobal( "XUB_Options_" .. aSlider .. "SliderLow" );
	
	if l == nil then
		XUB_ShowMessage( CCC(aSlider))
	end

	local v = s:GetValue() * 100;
	l:SetText(string.format("%3.0f",v) .. "%" );
	high:SetText( "100%" );
	low:SetText( "0%" );
end


function XUB_SliderLowHigh(aSlider,aLow,aHigh,aMultiplier,aFormat,aEdit)

	local s = getglobal( "XUB_Options_" .. aSlider .. "Slider" );
	local l = getglobal( "XUB_Options_Label_" .. aSlider .. "Label" );
	local high = getglobal( "XUB_Options_" .. aSlider .. "SliderHigh" );
	local low = getglobal( "XUB_Options_" .. aSlider .. "SliderLow" );

	local v = s:GetValue() * aMultiplier;
	l:SetText(string.format(aFormat,v) );
	high:SetText( aHigh );
	low:SetText( aLow );

	if ( aEdit ~= nil ) then
		aEdit:SetText(v);
	end
end

function XUB_Scroll(aSlider,aAmount)
	local s = getglobal( "XUB_Options_" .. aSlider .. "Slider" );
	s:SetValue(s:GetValue() + aAmount * s:GetValueStep() );
end

function XUB_ScrollVertical(aSlider,aAmount)
	local s = getglobal( aSlider .. "Slider" );
	s:SetValue(s:GetValue() - aAmount * s:GetValueStep() );
end

function XUB_COLORSelect()
	local R,G,B = ColorPickerFrame:GetColorRGB();
end
function XUB_ColorCancel(prevvals)
	local R,G,B = unpack(prevvals)
end

function XUB_SeletColor(aTexture)
	ColorPickerFrame.func = XUB_COLORSelect
	ColorPickerFrame.cancelFunc = XUB_ColorCancel

	ColorPickerFrame.hasOpacity = true;
	--ColorPickerFrame.previousValues = aTexture:GetColorRGB();
	ColorPickerFrame:Show();
end