local addonName, XUB = ...;

local XUB_PROFILE_SLICE = 5;
local XUB_DumpTime = GetTime();
local XUB_NEXT_PROFILE_TIME = XUB_DumpTime + XUB_PROFILE_SLICE;

XUB_Profile_Functions =
{    {func = XUB_UpdateUnitButtons2,       func_name = "XUB_UpdateUnitButtons2", inc=true}
	,{func = XUB_OnEvent,                  func_name = "XUB_OnEvent", inc=true}
	,{func = XUB_MeasureDamage,            func_name = "XUB_MeasureDamage", inc=true}
	,{func = XUB_OnUpdate,                 func_name = "XUB_OnUpdate", inc=false}
	,{func = XUB_ApplyGroup,               func_name = "XUB_ApplyGroup", inc=true}
	,{func = XUB_ApplyProfile,             func_name = "XUB_ApplyProfile", inc=true}
	,{func = XUB_Check_for_PartyChanges,   func_name = "XUB_Check_for_PartyChanges", inc=true}
	,{func = XUB_Check_for_RaidChanges,    func_name = "XUB_Check_for_RaidChanges", inc=true}
	,{func = XUB_Initialize_RaidFrameTable,func_name = "XUB_Initialize_RaidFrameTable", inc=true}
};

local XUB_Profiling_Data = {};

function XUB_CheckProfiling()

	if GetCVar("scriptProfile") == "1" then
		if GetTime() > XUB_NEXT_PROFILE_TIME then
 			XUB_NEXT_PROFILE_TIME = XUB_NEXT_PROFILE_TIME + XUB_PROFILE_SLICE;
 			XUB_StoreProfiling();
		end
	end

end


function XUB_StoreProfiling()

	UpdateAddOnCPUUsage();

	local Profile_Data = {};
	local Func_Data = {};

	Profile_Data.sys_time=GetTime();
	Profile_Data.addon_time = GetAddOnCPUUsage("eXtremeUnitButtons");
	Profile_Data.script_time = GetScriptCPUUsage();
	Profile_Data.func_data = {};

	for i=1,#XUB_Profile_Functions do

		Func_Data = {};

		Func_Data.func_name = XUB_Profile_Functions[i].func_name;
		Func_Data.func_time = GetFunctionCPUUsage(XUB_Profile_Functions[i].func, XUB_Profile_Functions[i].inc);
		table.insert(Profile_Data.func_data, Func_Data);
	end
	table.insert(XUB_Profiling_Data, Profile_Data);

end

function XUB_DumpProfiling()

local Profile_Data, Func_Data
	if GetCVar("scriptProfile") ~= "1" then
		XUB_ShowMessage("You must enable profiling to dump data,  '/script XUB_StartProfiling()' is one way");
	else
		XUB_ShowMessage("dumping XUB_Profiling_Data: " .. #XUB_Profiling_Data);
		for profile=1,#XUB_Profiling_Data do
			Profile_Data = XUB_Profiling_Data[profile];

			XUB_ShowMessage("At " .. Profile_Data.sys_time .. " cpu usage:" .. Profile_Data.addon_time .. ", script time:" .. Profile_Data.script_time );

			for func=1,#Profile_Data.func_data do
				unc_Data = Profile_Data.func_data[func];
				XUB_ShowMessage("   " .. Func_Data.func_name .. ":  " .. Func_Data.func_time);
			end

		end
	end
	XUB_Profiling_Data = {};
end

function XUB_StartProfiling()
	if GetCVar("scriptProfile") ~= "1" then
		SetCVar("scriptProfile", "1");
		ReloadUI();
	end
end

function XUB_StopProfiling()
	if GetCVar("scriptProfile") ~= "0" then
		SetCVar("scriptProfile", "0");
		ReloadUI();
	end
end
