local addonName, XUB = ...;

function XUB_Generate_Standard_Tooltip(myButton)

	XUB_GameTooltip:SetOwner(myButton,"ANCHOR_BOTTOMRIGHT");
	
	if (myButton.isMacro) then
		XUB_GameTooltip:AddLine(myButton.ToolTip,0,1,1,0);
	elseif (myButton.isUse) then
		XUB_GameTooltip:SetHyperlink("item:"..myButton.global_ID);
		XUB_GameTooltip:AddLine(myButton.ToolTip,0,1,1,0);
	else    
		XUB_GameTooltip:SetSpellByID(myButton.global_ID);
		XUB_GameTooltip:AddLine(myButton.ToolTip,0,1,1,0);
	end

	-- Cooldown:
	if ( myButton.is_STATE_COOLDOWN ) then

		local myReadableCooldown = XUB_Generate_CountdownText(myButton);

		if ( myReadableCooldown ~= "" ) then
			XUB_GameTooltip:AddLine("   ",0,1,1,0);
			XUB_GameTooltip:AddLine("remaining Cooldown: " .. myReadableCooldown,0,1,1,0);
		end

	end
end


function XUB_Generate_CooldownTooltip_in_combat(myButton)
-- Show minimal Tooltip containing Cooldown information even if in combat

	local myReadableCooldown = XUB_Generate_CountdownText(myButton);
	if ( myReadableCooldown ~= "" ) then
		XUB_GameTooltip:SetOwner(myButton,"ANCHOR_BOTTOMRIGHT");
		XUB_GameTooltip:AddLine(myReadableCooldown,0,1,1,0);
	end
end


function XUB_UpdateTooltip(myButton)

	if ( XUB.DEBUG > 0 ) then
		XUB_Generate_Standard_Tooltip(myButton);
		XUB_Add_DebugTooltip(myButton);
		XUB_GameTooltip:Show();
	elseif ( XUB.TOOLTIPS == "Always" ) then
		XUB_Generate_Standard_Tooltip(myButton);
		XUB_GameTooltip:Show();
	elseif ( XUB.TOOLTIPS == "Not In Combat" ) then
		if ( not InCombatLockdown() ) then
			XUB_Generate_Standard_Tooltip(myButton);
			XUB_GameTooltip:Show();
		end
	elseif ( XUB.TOOLTIPS == "Show Cooldown Even In Combat" ) then
		if ( not InCombatLockdown() ) then
			XUB_Generate_Standard_Tooltip(myButton);
			XUB_GameTooltip:Show();
		else
			if (myButton.is_STATE_COOLDOWN) then
				XUB_Generate_CooldownTooltip_in_combat(myButton);
				XUB_GameTooltip:Show();
			else
				XUB_GameTooltip:Hide();
			end
		end
	else
		XUB_GameTooltip:Hide();
	end

end


function XUB_ButtonMouseOver(self)

	XUB.MouseOveredButton = self;

	if (self~=nil) and (self.ToolTip ~= nil) then
		if ( XUB.TOOLTIPS ~= "Never" ) or ( XUB.DEBUG > 0 ) then
		-- Show the tooltip if tooltips are to be shown OR Debugging is ON

			if ( self.is_STATE_INVALID == nil) or ( XUB.DEBUG > 0 ) then
			-- Show the tooltip if the button is valid OR Debugging is ON

				XUB_UpdateTooltip(self);
			end
		end
	end

end

function XUB_ButtonMouseExit(self)
	XUB.MouseOveredButton = nil;
	XUB_GameTooltip:Hide();
end

function XUB_ShowFrameNames()
	local frame = EnumerateFrames()
	while frame do
		if frame:IsVisible() and MouseIsOver(frame) then
			XUB_ShowMessage(frame:GetName());
		end
		frame = EnumerateFrames(frame)
	end
end

