﻿local addonName, XUB = ...;

local manual_changes_found = nil

--XUB_UF_temp = { player = { "Name", "Frame", "Width" },}
local XUB_UF_temp = {
	Player    = { name = nil, frame = "PlayerFrame"               , width = 20 },
	PlayerPet = { name = nil, frame = "PetFrame"                  , width = 20 },
	Party     = { name = nil, frame = "PartyMemberFrame#"         , width = 20 },
	PartyPet  = { name = nil, frame = "PartyMemberFrame#PetFrame" , width = 20 },
	Arena     = { name = nil, frame = ""                          , width = 20 },
	Target    = { name = nil, frame = "TargetFrame"               , width = 20 },
	Focus     = { name = nil, frame = "FocusFrame"                , width = 20 },
	Custom1   = { name = "" , frame = ""                          , width = 20 },
	Custom2   = { name = "" , frame = ""                          , width = 20 },
	Custom3   = { name = "" , frame = ""                          , width = 20 },
	Custom4   = { name = "" , frame = ""                          , width = 20 },
	Custom5   = { name = "" , frame = ""                          , width = 20 },
	};

local XUB_RF_temp = {
	RaidMember = { name = nil, frame = "RaidPullout@Button#"              , width = 15 },
	RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)" , width = 15 },
	};



function XUB_UnitFrames_Open()
	XUB_UF_RefreshScreenFromSave();
	
	XUB_UnitframeConfig:Show();
end

function XUB_UF_Apply_UnitFrameAddon()

	local myDefault = XUB_UnitframeConfigUnitFrameAddonText:GetText();

	if ( myDefault == "agUnitFrames" ) then
		XUB_UF_temp = {
			Player    = { name = nil, frame = "aUFplayer"    , width = 20 },
			PlayerPet = { name = nil, frame = "aUFpet"       , width = 20 },
			Party     = { name = nil, frame = "aUFparty#"    , width = 20 },
			PartyPet  = { name = nil, frame = "aUFpartypet#" , width = 20 },
			Arena     = { name = nil, frame = ""             , width = 20 },
			Target    = { name = nil, frame = "aUFtarget"    , width = 20 },
			Focus     = { name = nil, frame = "aUFfocus"     , width = 20 },
			Custom1   = { name = "" , frame = ""             , width = 20 },
			Custom2   = { name = "" , frame = ""             , width = 20 },
			Custom3   = { name = "" , frame = ""             , width = 20 },
			Custom4   = { name = "" , frame = ""             , width = 20 },
			Custom5   = { name = "" , frame = ""             , width = 20 },
		};
	elseif ( myDefault == "Blizzard" ) then
		XUB_UF_temp = {
			Player    = { name = nil, frame = "PlayerFrame"               , width = 20 },
			PlayerPet = { name = nil, frame = "PetFrame"                  , width = 20 },
			Party     = { name = nil, frame = "PartyMemberFrame#"         , width = 20 },
			PartyPet  = { name = nil, frame = "PartyMemberFrame#PetFrame" , width = 20 },
			Arena     = { name = nil, frame = "ArenaEnemyFrame#"          , width = 20 },
			Target    = { name = nil, frame = "TargetFrame"               , width = 20 },
			Focus     = { name = nil, frame = "FocusFrame"                , width = 20 },
			Custom1   = { name = "targettarget" , frame = "TargetFrameToT", width = 20 },
			Custom2   = { name = "" , frame = ""                          , width = 20 },
			Custom3   = { name = "" , frame = ""                          , width = 20 },
			Custom4   = { name = "" , frame = ""                          , width = 20 },
			Custom5   = { name = "" , frame = ""                          , width = 20 },
		};
	elseif ( myDefault == "Blizzard compact" ) then
		XUB_UF_temp = {
			Player    = { name = nil, frame = "PlayerFrame"                      , width = 20 },
			PlayerPet = { name = nil, frame = "PetFrame"                         , width = 20 },
			Party     = { name = nil, frame = "CompactPartyFrameMember#"         , width = 20 },
			PartyPet  = { name = nil, frame = "CompactPartyFramePet#"            , width = 20 },
			--Arena     = { name = nil, frame = "CompactArenaFrameMember#"         , width = 20 },
			Arena     = { name = nil, frame = "ArenaEnemyFrame#"                 , width = 20 },
			Target    = { name = nil, frame = "TargetFrame"                      , width = 20 },
			Focus     = { name = nil, frame = "FocusFrame"                       , width = 20 },
			Custom1   = { name = "targettarget" , frame = "TargetFrameToT"                                 , width = 20 },
			Custom2   = { name = "" , frame = ""                                 , width = 20 },
			Custom3   = { name = "" , frame = ""                                 , width = 20 },
			Custom4   = { name = "" , frame = ""                                 , width = 20 },
			Custom5   = { name = "" , frame = ""                                 , width = 20 },
		};
	elseif ( myDefault == "XPerl" ) then
		XUB_UF_temp = {
			Player    = { name = nil, frame = "XPerl_Player"    , width = 20 },
			PlayerPet = { name = nil, frame = "XPerl_Player_Pet", width = 20 },
			Party     = { name = nil, frame = "XPerl_party#"    , width = 20 },
			PartyPet  = { name = nil, frame = "XPerl_partypet#" , width = 20 },
			Arena     = { name = nil, frame = ""                , width = 20 },
			Target    = { name = nil, frame = "XPerl_Target"    , width = 20 },
			Focus     = { name = nil, frame = "XPerl_Focus"     , width = 20 },
			Custom1   = { name = "" , frame = ""                , width = 20 },
			Custom2   = { name = "" , frame = ""                , width = 20 },
			Custom3   = { name = "" , frame = ""                , width = 20 },
			Custom4   = { name = "" , frame = ""                , width = 20 },
			Custom5   = { name = "" , frame = ""                , width = 20 },
		};
	elseif ( myDefault == "Discord Unit Frames" ) then
		XUB_UF_temp = {
			Player    = { name = nil, frame = "DUF_PlayerFrame"    , width = 20 },
			PlayerPet = { name = nil, frame = "DUF_PetFrame"       , width = 20 },
			Party     = { name = nil, frame = "DUF_PartyFrame#"    , width = 20 },
			PartyPet  = { name = nil, frame = "DUF_PartyPetFrame#" , width = 20 },
			Arena     = { name = nil, frame = ""                   , width = 20 },
			Target    = { name = nil, frame = "DUF_TargetFrame"    , width = 20 },
			Focus     = { name = nil, frame = "DUF_FocusFrame"     , width = 20 },
			Custom1   = { name = "" , frame = ""             , width = 20 },
			Custom2   = { name = "" , frame = ""             , width = 20 },
			Custom3   = { name = "" , frame = ""             , width = 20 },
			Custom4   = { name = "" , frame = ""             , width = 20 },
			Custom5   = { name = "" , frame = ""             , width = 20 },
		};
	elseif ( myDefault == "Perl Classic Frames" ) then
		XUB_UF_temp = {
			Player    = { name = nil, frame = "Perl_Player_Frame"        , width = 20 },
			PlayerPet = { name = nil, frame = "Perl_Player_Pet_Frame"    , width = 20 },
			Party     = { name = nil, frame = "Perl_Party_MemberFrame#"  , width = 20 },
			PartyPet  = { name = nil, frame = "Perl_Party_Pet#"          , width = 20 },
			Arena     = { name = nil, frame = ""                         , width = 20 },
			Target    = { name = nil, frame = "Perl_Target_Frame"        , width = 20 },
			Focus     = { name = nil, frame = "Perl_Focus_Frame"         , width = 20 },
			Custom1   = { name = "targettarget" , frame = "Perl_Target_Target_Frame"             , width = 20 },
			Custom2   = { name = "" , frame = ""                         , width = 20 },
			Custom3   = { name = "" , frame = ""                         , width = 20 },
			Custom4   = { name = "" , frame = ""                         , width = 20 },
			Custom5   = { name = "" , frame = ""                         , width = 20 },
		};
--[[	elseif ( myDefault == "Sage" ) then
		XUB_UF_Apply( "Player" , "Sageplayer" );
		XUB_UF_Apply( "PlayerPet" , "Sagepet" );
		XUB_UF_Apply( "Party" , "Sageparty#" );
		XUB_UF_Apply( "PartyPet" , "Sagepartypet#" );
		XUB_UF_Apply( "Target" , "Sagetarget" );
		XUB_UF_Apply( "Focus" , "Sagefocus" );
	elseif ( myDefault == "Sage only" ) then
		XUB_UF_Apply( "Player" , "player" );
		XUB_UF_Apply( "PlayerPet" , "pet" );
		XUB_UF_Apply( "Party" , "party#" );
		XUB_UF_Apply( "PartyPet" , "partypet#" );
		XUB_UF_Apply( "Target" , "target" );
		XUB_UF_Apply( "Focus" , "focus" );
	elseif ( myDefault == "SageFrame" ) then
		XUB_UF_Apply( "Player" , "SageFrameplayer" );
		XUB_UF_Apply( "PlayerPet" , "SageFramepet" );
		XUB_UF_Apply( "Party" , "SageFrameparty#" );
		XUB_UF_Apply( "PartyPet" , "SageFramepartypet#" );
		XUB_UF_Apply( "Target" , "SageFrametarget" );
		XUB_UF_Apply( "Focus" , "SageFramefocus" );
	elseif ( myDefault == "SageClick" ) then
		XUB_UF_Apply( "Player" , "SageClickplayer" );
		XUB_UF_Apply( "PlayerPet" , "SageClickpet" );
		XUB_UF_Apply( "Party" , "SageClickparty#" );
		XUB_UF_Apply( "PartyPet" , "SageClickpartypet#" );
		XUB_UF_Apply( "Target" , "SageClicktarget" );
		XUB_UF_Apply( "Focus" , "SageClickfocus" ); --]]
	elseif ( myDefault == "Shadowed UI" ) then
		XUB_UF_temp = {
			Player    = { name = nil, frame = "SUFUnitplayer"                , width = 20 },
			PlayerPet = { name = nil, frame = "SUFUnitpet"                   , width = 20 },
			Party     = { name = nil, frame = "SUFHeaderpartyUnitButton#"    , width = 20 },
			PartyPet  = { name = nil, frame = "SUFChildpartypet#"            , width = 20 },
			Arena     = { name = nil, frame = ""                             , width = 20 },
			Target    = { name = nil, frame = "SUFUnittarget"                , width = 20 },
			Focus     = { name = nil, frame = "SUFUnitfocus"                 , width = 20 },
			Custom1   = { name = "" , frame = ""             , width = 20 },
			Custom2   = { name = "" , frame = ""             , width = 20 },
			Custom3   = { name = "" , frame = ""             , width = 20 },
			Custom4   = { name = "" , frame = ""             , width = 20 },
			Custom5   = { name = "" , frame = ""             , width = 20 },
		};
	elseif ( myDefault == "PitBull" ) then -- PitBull4 changes from JoSchY
		XUB_UF_temp = {
			Player    = { name = nil                 , frame = "PitBull4_Frames_player"             , width = 20 },
			PlayerPet = { name = nil                 , frame = "PitBull4_Frames_pet"                , width = 20 },
			Party     = { name = nil                 , frame = "PitBull4_Groups_partyUnitButton#"   , width = 20 },
			PartyPet  = { name = nil                 , frame = "PitBull4_Groups_partypetUnitButton#", width = 20 },
			Arena     = { name = nil                 , frame = ""                                   , width = 20 },
			Target    = { name = nil                 , frame = "PitBull4_Frames_target"             , width = 20 },
			Focus     = { name = nil                 , frame = "PitBull4_Frames_focus"              , width = 20 },
			Custom1   = { name = "targettarget"      , frame = "PitBull4_Frames_targettarget"       , width = 20 },
			Custom2   = { name = "targettargettarget", frame = "PitBull4_Frames_targettargettarget" , width = 20 },
			Custom3   = { name = "focustarget"       , frame = "PitBull4_Frames_focustarget"        , width = 20 },
			Custom4   = { name = ""                  , frame = ""        , width = 20 },
			Custom5   = { name = ""                  , frame = ""        , width = 20 },
		};
	end
	XUB_UF_Apply_FrameAddonSettings(XUB_UF_temp, false)
end

function XUB_UF_Apply_RaidFrameAddon()

	local myDefault = XUB_UnitframeConfigRaidFrameAddonText:GetText();
	
	XUB.RaidUnitframesConfigured = 1;

	if ( myDefault == "Blizzard" ) then
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "RaidPullout@Button#"                        , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	elseif ( myDefault == "Blizzard compact" ) then
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "CompactRaidGroup@Member#"                   , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	elseif ( myDefault == "agUnitFrames" ) then
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "aUFgroup@UnitButton#"                       , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	elseif ( myDefault == "CTRaid" ) then
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "XUB finds CTRaid raid frames automatically" , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	elseif ( myDefault == "PerfectRaid" ) then
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "PRHeader@UnitButton#"                       , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	elseif ( myDefault == "PitBull" ) then
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "PitBull4_Groups_RaidUnitButton#"            , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	elseif ( myDefault == "Shadowed UI" ) then
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "SUFHeaderraidUnitButton#"                   , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	elseif ( myDefault == "XPerl" ) then
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "XUB finds XPerl raid frames automatically"  , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	elseif ( myDefault == "no raid buttons" ) then
			XUB.RaidUnitframesConfigured = nil;
		XUB_RF_temp = {
		RaidMember = { name = nil, frame = "XUB will not display raid buttons"          , width = 15 },
		RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
		};
	end
	XUB_UF_Apply_FrameAddonSettings(XUB_RF_temp, false)
end

function XUB_UF_Apply_FrameAddonSettings(my_temp_table,action_set_width)
	for k,v in pairs(my_temp_table) do
		if ( v.name ) then
			getglobal( "XUB_UnitframeConfig" .. k .. "Name"):SetText(v.name);
		end
		getglobal( "XUB_UnitframeConfig" .. k .. "Frame"):SetText(v.frame);
		if action_set_width==true then
			getglobal( "XUB_UnitframeConfig" .. k .. "WidthLabel"):SetText(v.width);
		end    
	end
end

function XUB_UF_UserChoice(myFrameType,xub_userchoice, mySelectedButton)

	--XUB_ShowMessage("My Choice:" .. CCC(xub_userchoice));
	
	UIDropDownMenu_SetSelectedID(myFrameType, xub_userchoice, 0);
	
	if mySelectedButton ~= "raid" then
		XUB_UF_Apply_UnitFrameAddon()
	else
		XUB_UF_Apply_RaidFrameAddon()
	end
end

function XUB_UF_RefreshScreenFromSave()

-- Apply UnitFrame settings
	XUB_UF_temp = XUB.UF
	XUB_UF_Apply_FrameAddonSettings(XUB_UF_temp,true)

-- Apply RaidFrame settings
	XUB_RF_temp = XUB.RF
	XUB_UF_Apply_FrameAddonSettings(XUB_RF_temp,true)

-- Remove checkmark in the menu
	UIDropDownMenu_SetSelectedID(XUB_UnitframeConfigUnitFrameAddon, 0, 0)
	UIDropDownMenu_SetSelectedID(XUB_UnitframeConfigRaidFrameAddon, 0, 0)

-- Set Text
	XUB_UnitframeConfigUnitFrameAddonText:SetText(XUB.UF_UnitFrameAddon);
	XUB_UnitframeConfigRaidFrameAddonText:SetText(XUB.RF_RaidFrameAddon);
	
--    UIDropDownMenu_SetSelectedName(XUB_UnitframeConfigUnitFrameAddon, XUB.UF_UnitFrameAddon, 0)
--    UIDropDownMenu_SetSelectedName(XUB_UnitframeConfigRaidFrameAddon, XUB.RF_RaidFrameAddon, 0)
end

function XUB_UF_GetUserInput(my_temp_table)

	manual_changes_found = nil

	for k,v in pairs(my_temp_table) do
	if ( v.name ) then
			v.name = getglobal( "XUB_UnitframeConfig" .. k .. "Name"):GetText();
	end
	if v.frame ~= getglobal( "XUB_UnitframeConfig" .. k .. "Frame"):GetText() then
			manual_changes_found = true
	end    
	v.frame = getglobal( "XUB_UnitframeConfig" .. k .. "Frame"):GetText();
	v.width = getglobal( "XUB_UnitframeConfig" .. k .. "WidthLabel"):GetText();
	end

	return manual_changes_found
end

function XUB_UF_SaveScreen()

	manual_changes_found = XUB_UF_GetUserInput(XUB_UF_temp)
	XUB.UF = XUB_UF_temp
	if ( manual_changes_found ) then
		XUB_UnitframeConfigUnitFrameAddonText:SetText("-- Custom UF Settings --")
	end    

	manual_changes_found = XUB_UF_GetUserInput(XUB_RF_temp)
	XUB.RF = XUB_RF_temp
	if ( manual_changes_found ) then
		XUB_UnitframeConfigRaidFrameAddonText:SetText("-- Custom RF settings --")
	end    

	
	XUB.UF_UnitFrameAddon = XUB_UnitframeConfigUnitFrameAddonText:GetText();
	XUB.RF_RaidFrameAddon = XUB_UnitframeConfigRaidFrameAddonText:GetText();

	XUB.RaidUnitframesConfigured = 1;
	if ( XUB.RF_RaidFrameAddon == "no raid buttons") then
		XUB.RaidUnitframesConfigured = nil;
	end

	XUB_ShowMessage("XUB Unit frames: " .. XUB.UF_UnitFrameAddon);
	XUB_ShowMessage("XUB Raid frames: " .. XUB.RF_RaidFrameAddon);
end

function XUB_UF_Scroll(aUnit,delta)
	local myTextField = getglobal( "XUB_UnitframeConfig" .. aUnit .. "WidthLabel" );
	local NUM = tonumber(myTextField:GetText()) + delta;
	if ( NUM < 5 ) then
		NUM = 5;
	end
	myTextField:SetText(NUM);
end

function XUB_UF_Save()
	XUB_RemoveButtons(); 
	XUB_UF_SaveScreen(); 
	XUB.manualChange = 1;
	XUB_ApplyProfile(XUB.CurrentProfile);
end