﻿-- Original code and content was developed by Elenesski.
-- The addon is currently maintained by Paladindrome and tayedaen
-- Version 2 does have almost no code left untouched from the original project ;-)

--  Copyright Disclaimer: While you are free to copy code from this addon
--  we would aks that you acknowledge the source, and where you got the code.

-- Creation Date : 2010-12-01
-- Version       : 2.0 RC2

-- Acknowledgements: 2007-Jan-12 PartyBars - For showing me that a GroupButtons-like mod was possible.
-- 	               2007-Jan-27 Shaymon   - For identifying Spells with quotes don't work.  Fixed in v0.9.01
-- 	               2007-Jan-28 Borohir   - For providing GameTooltip code which allows tooltips to be added -- Now with additional features.
-- 	               2007-Jan-28 Borohir   - For providing code to show colors -- Now an option.

-- The idea of eXtreme Unit Buttons (XUB) orginally based on Party Buttons who was trying to replicate
-- the broken mod called GroupButtons written by Loz.
-- Party Bars used the Action Button Bars which as a limit of 120.  XUB has no such limit, and will be made to be
-- completely configurable.


local addonName, XUB = ...;

--
-- Saved Variables (and their presets)
--
XUB.ENABLE_ALPHA     = 1;
XUB.BUFFED_ALPHA     = 0.2;
XUB.COOLDOWN_ALPHA   = 0.5;
XUB.NOMANA_ALPHA     = 0.05;
XUB.OUTOFRANGE_ALPHA = 0.2;
XUB.INVALID_ALPHA    = 0;

XUB.ANCHOR = "TOPRIGHT";
XUB.BUTTON_SPACING = 1;
XUB.ButtonSize = 64;
XUB.CHANGEDELAY = 5;        -- How many second delay when party/raid members change?
XUB.COLORUSAGE = "Color Coded";   --Red=Range,Ochre=Buffed,Purple=Cooldown,Cobalt=Mana
XUB.CustomButtons = {}
XUB.ConfigGroups = {}
XUB.ConfigProfiles = {}
XUB.COUNTDOWN = 0;
XUB.CurrentProfile = "";
XUB.GROUPSPACING = 20;
XUB.HEALACTION = "Show as Buffed";
XUB.QUEUESIZE = 10;         -- How many units are updated per refresh?
XUB.ShowDecimals = nil;
XUB.ShowPartyInRaid = nil;
XUB.TOOLTIPS = "Always";
XUB.UPDATERATE = 0.5;
XUB.USE_BUILTIN_COOLDOWN = 1;
XUB.USE_GLOBALDIM = 0;
XUB.Use_RightButton = "RightButtonUp"
XUB.Use_MiddleButton = "MiddleButtonUp"
XUB.Use_Button4 = "Button4Up"
XUB.Use_Button5 = "Button5Up"
XUB.Profile_for_Spec = { "",""}

XUB.UF = {
	Player    = { name = nil, frame = "PlayerFrame"               , width = 20 },
	PlayerPet = { name = nil, frame = "PetFrame"                  , width = 20 },
	Party     = { name = nil, frame = "PartyMemberFrame#"         , width = 20 },
	PartyPet  = { name = nil, frame = "PartyMemberFrame#PetFrame" , width = 20 },
	Target    = { name = nil, frame = "TargetFrame"               , width = 20 },
	Focus     = { name = nil, frame = "FocusFrame"                , width = 20 },
	Custom1   = { name = "" , frame = ""                          , width = 20 },
	Custom2   = { name = "" , frame = ""                          , width = 20 },
	Custom3   = { name = "" , frame = ""                          , width = 20 },
	Custom4   = { name = "" , frame = ""                          , width = 20 },
	Custom5   = { name = "" , frame = ""                          , width = 20 },
};
XUB.UF_UnitFrameAddon = "Blizzard";

XUB.RF = {
	RaidMember = { name = nil, frame = "XUB will not display raid buttons"          , width = 15 },
	RaidPet    = { name = nil, frame = "RaidPets are not supported (yet)"           , width = 15 },
};
XUB.RF_RaidFrameAddon = "no raid buttons" 

XUB.UF_WIDTH_Float = 20
--
-- End of Saved Variables
--


XUB.FRAME_STRATA = "LOW";  --MEDIUM
XUB.BUTTON_STRATA = "NORMAL"; --NORMAL

XUB.LastHealthTarget = 0;       -- Approximate health points left on the target
XUB.HealthLeftTarget = 0;       -- Exact health of target in % (after last damage event)
XUB.LastDamageTarget = 0;       -- Damage amount of last attack

XUB.Buttons_for_Dest = {}       -- contains number of buttons for a destination unit (units like player, target, focus, party1, ..)
XUB.RaidFrameTable = {};        -- Keeps track of the frames that correspond to the raid#'s
XUB.PartyFrameTable = {};       -- Keeps track of the frames that correspond to the party and partypet #'s
XUB.ArenaFrameTable = {};
XUB.ConfiguredUnits = {};				-- contains all unitIDs that are used in the current configuration
XUB.Coords_for_Next_Button = {} -- stores the coordinates for the next button to be created for a certain unit
XUB.StandardButtons = {}    		-- System Buttons (in Array Form)
XUB.ButtonQueue = {}            -- Created Buttons, contains all buttons for all units

XUB.NextUpdate = 25;            -- Constantly modified variable, identifying when the next update takes place

XUB.QUEUEPTR    = 9999;     -- PTR in the updatequeue
XUB.UPDATEUNITS = {};       -- Which units have frames which require updating

-- XUB COLOR DEFINITION BLOCK
-- Colorcodes : see http://www.wowwiki.com/User:Tinkerer/Colour
-- Take the R G B values from the page, and divide them by 255
-- Next lines set the colors for the different states if 'Color coded' is used instead of 'Transparency'
XUB.COLORS = { select       = { r = 0.8, g = 0.8, b = 0.8 },
				c_range      = { r = 0.8, g = 0.1, b = 0.1 },    -- redish
				c_outofmana  = { r = 0.0, g = 0.28, b = 0.67 },  -- cobalt
				c_cooldown   = { r = 0.4, g = 0.0, b = 0.59 },   -- purple
				c_buffed     = { r = 0.8, g = 0.46, b = 0.13 },  -- ochre
				c_globaldim  = { r = 0.59, g = 1.0, b = 0.59 },  -- mint
-- 	           red    = { r = 1.0, g = 0.0, b = 0.0 },
-- 	           blue   = { r = 0.0, g = 0.0, b = 1.0 },
-- 	           green  = { r = 0.0, g = 1.0, b = 0.0 },
-- 	           purple = { r = 0.4, g = 0.0, b = 0.59 },     -- 102      0     153
-- 	           cobalt   = { r = 0.0, g = 0.28, b = 0.67 },  --   0     71     171
-- 	           mint   = { r = 0.59, g = 1.0, b = 0.59 },    -- 152    255     152
-- 	           mustard = { r = 1.0, g = 0.85, b = 0.34 },   -- 255    219      88
-- 	           ochre  = { r = 0.8, g = 0.46, b = 0.13 },    -- 204    119      34
}

XUB.BLINKRATE = 0.5;
XUB.GLOBALDIM_ALPHA  = 0.05;
XUB.delay_after_automaticProfileChange = 0;
XUB.delay_after_manualProfileChange = 3;
XUB.manualChange = nil;
XUB.CountDown_before_checking_for_changes = -1; 	-- # seconds to wait before checking for changes (raid/group/spell/talent changes)
XUB.GLOBALDIM_active = 0;
XUB.SilentTest = nil;

XUB.LEARNED_SPELL_IN_TAB = 0
XUB.PARTY_MEMBERS_CHANGED = 0
XUB.RAID_ROSTER_UPDATE = 0
XUB.ProfileChange = 0
XUB.GroupType = "solo"

XUB.Busy = 0;
XUB.ChangesToBeApplyAfterCombat=nil;
XUB.DEBUG = 0;
XUB.MakeInitialisation = 2;
XUB.MouseOveredButton = nil;
XUB.RaidUnitframesConfigured = nil;

XUB.UnitsInVehicles = {}

--transformed tables
XUB.ProfileDescription = {}
XUB.GroupDescription = {}
XUB.ButtonDescription = {}
XUB.profileNames = {}


function XUB_OnLoad(self)

	XUB_WeaponTooltip = CreateFrame("GameTooltip", "XUB_ParseToolTip", nil, "GameTooltipTemplate");
	XUB_WeaponTooltip:SetOwner(WorldFrame, "ANCHOR_NONE");

	XUB_GameTooltip = CreateFrame("GameTooltip", "XUB_ShowToolTip", nil, "GameTooltipTemplate");
	local myFontSize = 20;
	local myScale = 0.7 * GameTooltip:GetScale();
	XUB_GameTooltip:SetScale(myScale);

	XUB.LDB_Menu = CreateFrame( "Frame", "XUB_LDB_Menu")
	XUB.LDB_Menu.displayMode = "MENU"
	
	self:SetScript("OnEvent",XUB_OnEvent);
	self:RegisterEvent("PLAYER_LOGIN");
	
	--XUB.DEBUG=1
	--XUB_ShowMessage("XUB-debug: OnLoad finished");

-- 	collectgarbage("stop");
end

--
-- Event Handler .. just a laundry list of events
--
function XUB_OnEvent(self, event, arg1, ...)

	XUB_ShowDebugMessage("XUB: "..CCC(event) .." received")
	--XUB.LastEvent = event
	--XUB.LastArg = arg1
	
		--local arg2,arg3,arg4 = ...;

	if (event == "PLAYER_LOGIN") then       --Loading of the addon and the saved variables per player complete
		--XUB_StopProfiling();
		XUB_ConvertSaved();                                 -- conversion of saved variables from older versions
		self:RegisterEvent("PLAYER_LOGOUT");

		XUB.DismissFirstOnUpdateCycles = 3
		PBFrame:SetScript("OnUpdate",XUB_OnUpdate);         -- start the OnUpdate Cycle
	elseif (event == "PLAYER_ENTERING_WORLD") then          -- Loading of EVERYTHING complete
		if XUB.LEARNED_SPELL_IN_TAB > 0 then
			XUB.LEARNED_SPELL_IN_TAB = 0;
			XUB.CountDown_before_checking_for_changes = -1
		end
		-- band aid fix for "instance leaving makes you leave your group" ...
		if (XUB.GroupType ~= "solo") and (GetNumPartyMembers() < 1) then
			XUB.GroupType = "solo"
			XUB_ShowDebugMessage("XUB-debug: Starting apply because player is now playing solo again")
			XUB.manualChange = nil;
			XUB_ApplyProfile(XUB.CurrentProfile);
		else
			XUB.NextUpdate = 2;                     			-- wait 2 seconds after ReloadUI before starting the OnUpdate cycles again
		end
	elseif (event == "PLAYER_REGEN_ENABLED") then           -- Combat finished
		if  ( XUB.ChangesToBeApplyAfterCombat ) then
			XUB.ProfileChange = XUB.ProfileChange + 1;
			XUB.CountDown_before_checking_for_changes = 0.1;
		end
	elseif (event == "ACTIVE_TALENT_GROUP_CHANGED") then           -- Player changed his specc (dual specc)
		if XUB.Profile_for_Spec[arg1] and XUB.Profile_for_Spec[arg1] ~= "" then
			XUB.CurrentProfile = XUB.Profile_for_Spec[arg1]
		end
		XUB.LEARNED_SPELL_IN_TAB = XUB.LEARNED_SPELL_IN_TAB +1;
		XUB.CountDown_before_checking_for_changes = 1;
	elseif (event == "PARTY_CONVERTED_TO_RAID") then
		XUB.RAID_ROSTER_UPDATE = XUB.RAID_ROSTER_UPDATE +1;
		XUB.CountDown_before_checking_for_changes = XUB.CHANGEDELAY; 	-- wait because often these events occur more then once
	elseif (event == "PARTY_MEMBERS_CHANGED") then
		XUB.PARTY_MEMBERS_CHANGED = XUB.PARTY_MEMBERS_CHANGED + 1;
		XUB.CountDown_before_checking_for_changes = XUB.CHANGEDELAY; 	-- wait because often these events occur more then once
	elseif (event == "RAID_ROSTER_UPDATE") then
		XUB.RAID_ROSTER_UPDATE = XUB.RAID_ROSTER_UPDATE +1;
		XUB.CountDown_before_checking_for_changes = XUB.CHANGEDELAY; 	-- wait because often these events occur more then once
	elseif (event == "LEARNED_SPELL_IN_TAB") or (event == "SPELLS_CHANGED") then
		XUB.LEARNED_SPELL_IN_TAB = XUB.LEARNED_SPELL_IN_TAB +1;
		XUB.CountDown_before_checking_for_changes = 2;
	elseif (event == "UNIT_ENTERED_VEHICLE") then
		XUB_ShowMessage("Entered: " .. CCC(arg1))
		if XUB.Buttons_for_Dest[arg1] then
			XUB.PARTY_MEMBERS_CHANGED = XUB.PARTY_MEMBERS_CHANGED + 1;
			XUB.UnitsInVehicles[arg1] = 1;
			XUB.CountDown_before_checking_for_changes = 0.1;
		end
	elseif (event == "UNIT_EXITED_VEHICLE") then
		XUB_ShowMessage("Exited: " .. CCC(arg1))
		if XUB.Buttons_for_Dest[arg1] then
			XUB.PARTY_MEMBERS_CHANGED = XUB.PARTY_MEMBERS_CHANGED + 1;
			XUB.UnitsInVehicles[arg1] = nil;
			XUB.CountDown_before_checking_for_changes = 0.1;
		end
	elseif (event == "UNIT_SPELLCAST_START") then
		--XUB_ShowMessage("Been here: " .. CCC(arg1) .. " | " .. CCC(arg2));
		if ( arg1 == "player" ) then
			XUB.GLOBALDIM_active = 1;

			self:UnregisterEvent("UNIT_SPELLCAST_START");
			self:RegisterEvent("UNIT_SPELLCAST_STOP");
			self:RegisterEvent("UNIT_SPELLCAST_FAILED");
			self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED");
			self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
		end
	elseif (event == "UNIT_SPELLCAST_STOP") or
			(event == "UNIT_SPELLCAST_STOP") or
			(event == "UNIT_SPELLCAST_FAILED") or
			(event == "UNIT_SPELLCAST_INTERRUPTED") or
			(event == "UNIT_SPELLCAST_SUCCEEDED") then
		if ( arg1 == "player" ) then
			XUB.GLOBALDIM_active = 0;
			self:RegisterEvent("UNIT_SPELLCAST_START");
			self:UnregisterEvent("UNIT_SPELLCAST_STOP");
			self:UnregisterEvent("UNIT_SPELLCAST_FAILED");
			self:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
			self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED");
		end
	elseif (event == "PLAYER_LOGOUT") then
		XUB_SavedVariables_local2Global()
	end

end

--
-- Handle any slash commands entered
--
function XUB_SlashCommandHandler(msg)

	local a, b, command, myparameter = string.find( msg, "(%w*)[ ]*([%w/]*)" );

	command = string.lower(command);

	if ( command == "debug" ) then
		if XUB.DEBUG == 1 then
			XUB.DEBUG = 0;
			XUB_ShowMessage( "XUB: Debugging is now OFF" );
		else
			XUB.DEBUG = 1;
			XUB_ShowMessage( "XUB: Debugging is now ON" );
		end
		return;

	elseif ( command == "showdecimals" ) then

		if (XUB.ShowDecimals ) then
			XUB.ShowDecimals = nil;
			XUB_ShowMessage( "XUB: Countdown displayed without decimals." );
		else
			XUB.ShowDecimals = 1;
			XUB_ShowMessage( "XUB: Countdown displayed with decimals." );
		end
		return;

	elseif ( command == "useglobaldim" ) then

		if XUB.USE_GLOBALDIM == 1 then
			XUB.USE_GLOBALDIM = 0;
			PBFrame:UnregisterEvent("UNIT_SPELLCAST_START");
			PBFrame:UnregisterEvent("UNIT_SPELLCAST_STOP");
			PBFrame:UnregisterEvent("UNIT_SPELLCAST_FAILED");
			PBFrame:UnregisterEvent("UNIT_SPELLCAST_INTERRUPTED");
			PBFrame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED");
			XUB_ShowMessage( "XUB: Use Global Dim is now OFF" );
		else
			XUB.USE_GLOBALDIM = 1;
			PBFrame:RegisterEvent("UNIT_SPELLCAST_START");
			XUB_ShowMessage( "XUB: Use Global Dim is now ON" );
		end
		return;

	elseif ( command == "list" ) then

		XUB_ShowMessage("BUTTONS (Custom buttons)");
		for i=1,#XUB.CustomButtons do
			myItems = XUB.CustomButtons[i];
			XUB_ShowMessage("   Name: " .. myItems[1] .. "    Type: " .. myItems[2]);
		end

		XUB_ShowMessage("  ");
		XUB_ShowMessage("GROUPS");
		for i=1,#XUB.ConfigGroups do
			myItems = XUB.ConfigGroups[i];
			XUB_ShowMessage("   Groupname: " .. myItems[1] .. "    Spellname: " .. myItems[2]);
		end

		XUB_ShowMessage("  ");
		XUB_ShowMessage("PROFILES");
		for i=1,#XUB.ConfigProfiles do
			myItems = XUB.ConfigProfiles[i];
			XUB_ShowMessage("   profile Name: " .. myItems[1] .. "    on unit: " .. myItems[2] .. " using group '" .. myItems[3] .. "'" );
		end

		local myUseButtonList = "LeftButtonUp"
		if XUB.Use_RightButton then
			myUseButtonList = myUseButtonList .. ", RightButtonUp"
		end
		if XUB.Use_MiddleButton then
			myUseButtonList = myUseButtonList .. ", MiddleButtonUp"
		end
		if XUB.Use_Button4 then
			myUseButtonList = myUseButtonList .. ", Button4Up"
		end
		if XUB.Use_Button5 then
			myUseButtonList = myUseButtonList .. ", Button5Up"
		end
		XUB_ShowMessage("  ");
		XUB_ShowMessage( "Used Buttons: " )
		XUB_ShowMessage( myUseButtonList )

		return;

	elseif ( command == "profile" ) or ( command == "p" ) then
		local profile = string.lower(myparameter);

		if ( profile == "" ) then
			profile = XUB.CurrentProfile;
		end
		XUB.manualChange = 1;
		XUB_ApplyProfile(profile);
		return;
	end

	if ( InCombatLockdown() ) then
		XUB_ShowMessage( "**************************************************************************" );
		XUB_ShowMessage( "** XUB CANNOT ISSUE COMMANDS WHILE IN COMBAT **" );
		XUB_ShowMessage( "**************************************************************************" );

	elseif ( command == "config" ) or ( command == "c" ) then
		XUB_Config_Open()

	elseif ( command == "options" ) or ( command == "o" ) then
				XUB_Options_Open()

	elseif ( command == "unitframes" ) or ( command == "uf" ) then
				XUB_UnitFrames_Open()
				
	elseif ( command == "floatwidth" )  or ( command == "fw" ) then
		local floatwidth = myparameter;
		if ( floatwidth ~= "" ) then
			XUB.UF_WIDTH_Float = floatwidth;
			XUB_RemoveButtons_for_SingleUnit("float",nil);
			XUB.manualChange = 1;
			XUB_ApplyProfile_for_SingleUnit(XUB.CurrentProfile,"float",0);
		else
			XUB_ShowMessage( "XUB: Error: No value specified.");
			XUB_ShowMessage( " Usage: /XUB floatwidth <value>   or   /XUB fw <value>" );
		end

	elseif ( command == "togglebutton" ) then

		local buttonlist = string.lower(myparameter);

		if string.find(buttonlist, "right" ) then
			if XUB.Use_RightButton then
				XUB.Use_RightButton = nil
			else
				XUB.Use_RightButton = "RightButtonUp"
			end
		end
		if string.find(buttonlist, "middle" ) then
			if XUB.Use_MiddleButton then
				XUB.Use_MiddleButton = nil
			else
				XUB.Use_MiddleButton = "MiddleButtonUp"
			end
		end
		if string.find(buttonlist, "button4" ) then
			if XUB.Use_Button4 then
				XUB.Use_Button4 = nil
			else
				XUB.Use_Button4 = "Button4Up"
			end
		end
		if string.find(buttonlist, "button5" ) then
			if XUB.Use_Button5 then
				XUB.Use_Button5 = nil
			else
				XUB.Use_Button5 = "Button5Up"
			end
		end

		XUB.manualChange = 1;
		XUB_ApplyProfile(XUB.CurrentProfile);

	elseif ( command == "showpartyinraid" ) then

		if ( XUB.ShowPartyInRaid ) then
			XUB.ShowPartyInRaid = nil;
			XUB_ShowMessage( "XUB: XUB no longer displays partybuttons while in raid" );
		else
			XUB.ShowPartyInRaid = 1;
			XUB_ShowMessage( "XUB: XUB now displays partybuttons while in raid" );
		end

		XUB.manualChange = 1;
		XUB_ApplyProfile(XUB.CurrentProfile);

	else
		command = string.lower( msg );

		XUB_ShowMessage( "eXtreme Unit Buttons (XUB)" );
		XUB_ShowMessage( " " );
		XUB_ShowMessage( "Commands" );
		XUB_ShowMessage( "  config (or c)              - Opens the button configuration panel" );
		XUB_ShowMessage( "  options (or o)             - Opens the global options window" );
		XUB_ShowMessage( "  unitframes (or uf)         - Here you can configure the names of your unit frames" );
		XUB_ShowMessage( "  profile (or p) <name>      - Changes the active profile to <name>" );
		XUB_ShowMessage( "  profile (or p)             - reapplies the active profile (redraws the buttons)" );
		XUB_ShowMessage( "  floatwidth (or fw) <value> - Changes the width for the float frame to <value>" );
		XUB_ShowMessage( "  useglobaldim               - toggles Global Dim" );
		XUB_ShowMessage( "  togglebutton <value>       - disables the use of buttons eg. 'togglebutton right middle button4 button5'" );
		XUB_ShowMessage( "  showpartyinraid            - toggles the displaying of butons for partyframes while in raid" );
		XUB_ShowMessage( "  debug                      - toggles Debugging" );
		XUB_ShowMessage( " " );
	end

end



function XUB_SetBackground(aFrame)
	aFrame:SetBackdrop({bgFile = "Interface\\Tooltips\\Nameplate-Glow",
						edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
						tile = true, tileSize = 16, edgeSize = 16,
						insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	aFrame:SetBackdropColor(0,0,0,1);
end


--
-- Writes a message to the default chat window
--
function XUB_ShowMessage(aMessage)
	if ( aMessage == nil ) then
		DEFAULT_CHAT_FRAME:AddMessage("XUB: NIL message");
	else
		DEFAULT_CHAT_FRAME:AddMessage(aMessage);
	end
end

function XUB_ErrorMessage(aMessage)
	if ( not XUB.SilentTest ) then
		XUB_ShowMessage(aMessage);
	end
end

